=== OMSimulator/3rdParty/cvode/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Radu Serban, David J. Gardner, Cody J. Balos,
#                and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2020, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# Top level CMakeLists.txt for SUNDIALS (for cmake build system)
# ---------------------------------------------------------------

# ---------------------------------------------------------------
# Initial commands
# ---------------------------------------------------------------

# Require CMake 3.5 by default, but certain options will force us
# to require CMake 3.10
cmake_minimum_required(VERSION 2.8)
include(CMakeParseArguments)  # For CMake 3.4 and lower

# Project SUNDIALS (initially only C supported)
# sets PROJECT_SOURCE_DIR and PROJECT_BINARY_DIR variables
project(sundials C)

# Set some variables with info on the SUNDIALS project
set(PACKAGE_BUGREPORT "woodward6@llnl.gov")
set(PACKAGE_NAME "SUNDIALS")
set(PACKAGE_STRING "SUNDIALS 5.3.0")
set(PACKAGE_TARNAME "sundials")

# set SUNDIALS version numbers
# (use "" for the version label if none is needed)
set(PACKAGE_VERSION_MAJOR "5")
set(PACKAGE_VERSION_MINOR "3")
set(PACKAGE_VERSION_PATCH "0")
set(PACKAGE_VERSION_LABEL "")

if(PACKAGE_VERSION_LABEL)
  set(PACKAGE_VERSION "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}-${PACKAGE_VERSION_LABEL}")
else()
  set(PACKAGE_VERSION "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}")
endif()

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# Prohibit in-source build
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  message(FATAL_ERROR "In-source build prohibited.")
endif("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")

# Hide some cache variables
mark_as_advanced(EXECUTABLE_OUTPUT_PATH LIBRARY_OUTPUT_PATH)

# Always show the C compiler and flags
mark_as_advanced(CLEAR
  CMAKE_C_COMPILER
  CMAKE_C_FLAGS)

# Specify the VERSION and SOVERSION for shared libraries

set(arkodelib_VERSION "4.3.0")
set(arkodelib_SOVERSION "4")

set(cvodelib_VERSION "5.3.0")
set(cvodelib_SOVERSION "5")

set(cvodeslib_VERSION "5.3.0")
set(cvodeslib_SOVERSION "5")

set(idalib_VERSION "5.3.0")
set(idalib_SOVERSION "5")

set(idaslib_VERSION "4.3.0")
set(idaslib_SOVERSION "4")

set(kinsollib_VERSION "5.3.0")
set(kinsollib_SOVERSION "5")

set(cpodeslib_VERSION "0.0.0")
set(cpodeslib_SOVERSION "0")

set(nveclib_VERSION "5.3.0")
set(nveclib_SOVERSION "5")

set(sunmatrixlib_VERSION "3.3.0")
set(sunmatrixlib_SOVERSION "3")

set(sunlinsollib_VERSION "3.3.0")
set(sunlinsollib_SOVERSION "3")

set(sunnonlinsollib_VERSION "2.3.0")
set(sunnonlinsollib_SOVERSION "2")

# Specify the location of additional CMAKE modules
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/config)

# Get correct build paths automatically, but expose CMAKE_INSTALL_LIBDIR
# as a regular cache variable so that a user can more easily see what
# the library dir was set to be by GNUInstallDirs.
include(GNUInstallDirs)
mark_as_advanced(CLEAR CMAKE_INSTALL_LIBDIR)

# ---------------------------------------------------------------
# Which modules to build?
# ---------------------------------------------------------------

# For each SUNDIALS solver available (i.e. for which we have the
# sources), give the user the option of enabling/disabling it.

if(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/arkode")
  option(BUILD_ARKODE "Build the ARKODE library" ON)
else()
  set(BUILD_ARKODE OFF)
endif()

if(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cvode")
  option(BUILD_CVODE "Build the CVODE library" ON)
else()
  set(BUILD_CVODE OFF)
endif()

if(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cvodes")
  option(BUILD_CVODES "Build the CVODES library" ON)
else()
  set(BUILD_CVODES OFF)
endif()

if(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/ida")
  option(BUILD_IDA "Build the IDA library" ON)
else()
  set(BUILD_IDA OFF)
endif()

if(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/idas")
  option(BUILD_IDAS "Build the IDAS library" ON)
else()
  set(BUILD_IDAS OFF)
endif()

if(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/kinsol")
  option(BUILD_KINSOL "Build the KINSOL library" ON)
else()
  set(BUILD_KINSOL OFF)
endif()

# CPODES is always OFF for now.  (commented out for Release); ToDo: better way to do this?
#IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cpodes")
#  OPTION(BUILD_CPODES  "Build the CPODES library"  OFF)
#ELSE()
#  SET(BUILD_CPODES OFF)
#ENDIF()

# ---------------------------------------------------------------
# MACRO definitions
# ---------------------------------------------------------------
include(SundialsCMakeMacros)

# ---------------------------------------------------------------
# Check for deprecated SUNDIALS CMake options/variables
# ---------------------------------------------------------------
include(SundialsDeprecated)

# ---------------------------------------------------------------
# xSDK specific options
# ---------------------------------------------------------------
include(SundialsXSDK)

# ---------------------------------------------------------------
# Build specific C flags
# ---------------------------------------------------------------

# Hide all build type specific flags
mark_as_advanced(FORCE
  CMAKE_C_FLAGS_DEBUG
  CMAKE_C_FLAGS_MINSIZEREL
  CMAKE_C_FLAGS_RELEASE
  CMAKE_C_FLAGS_RELWITHDEBINFO)

# Only show flags for the current build type if it is set
# NOTE: Build specific flags are appended those in CMAKE_C_FLAGS
if(CMAKE_BUILD_TYPE)
  if(CMAKE_BUILD_TYPE MATCHES "Debug")
    message("Appending C debug flags")
    mark_as_advanced(CLEAR CMAKE_C_FLAGS_DEBUG)
  elseif(CMAKE_BUILD_TYPE MATCHES "MinSizeRel")
    message("Appending C min size release flags")
    mark_as_advanced(CLEAR CMAKE_C_FLAGS_MINSIZEREL)
  elseif(CMAKE_BUILD_TYPE MATCHES "Release")
    message("Appending C release flags")
    mark_as_advanced(CLEAR CMAKE_C_FLAGS_RELEASE)
  elseif(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
    message("Appending C release with debug info flags")
    mark_as_advanced(CLEAR CMAKE_C_FLAGS_RELWITHDEBINFO)
  endif()
endif()

# ---------------------------------------------------------------
# Option to specify precision (realtype)
# ---------------------------------------------------------------

set(DOCSTR "single, double, or extended")
show_variable(SUNDIALS_PRECISION STRING "${DOCSTR}" "double")

# prepare substitution variable PRECISION_LEVEL for sundials_config.h
string(TOUPPER ${SUNDIALS_PRECISION} SUNDIALS_PRECISION)
set(PRECISION_LEVEL "#define SUNDIALS_${SUNDIALS_PRECISION}_PRECISION 1")

# prepare substitution variable FPRECISION_LEVEL for sundials_fconfig.h
if(SUNDIALS_PRECISION MATCHES "SINGLE")
  set(FPRECISION_LEVEL "4")
endif(SUNDIALS_PRECISION MATCHES "SINGLE")
if(SUNDIALS_PRECISION MATCHES "DOUBLE")
  set(FPRECISION_LEVEL "8")
endif(SUNDIALS_PRECISION MATCHES "DOUBLE")
if(SUNDIALS_PRECISION MATCHES "EXTENDED")
  set(FPRECISION_LEVEL "16")
endif(SUNDIALS_PRECISION MATCHES "EXTENDED")

# ---------------------------------------------------------------
# Option to specify index type
# ---------------------------------------------------------------

set(DOCSTR "Signed 64-bit (64) or signed 32-bit (32) integer")
show_variable(SUNDIALS_INDEX_SIZE STRING "${DOCSTR}" "64")
set(DOCSTR "Integer type to use for indices in SUNDIALS")
show_variable(SUNDIALS_INDEX_TYPE STRING "${DOCSTR}" "")
mark_as_advanced(SUNDIALS_INDEX_TYPE)
include(SundialsIndexSize)

# ---------------------------------------------------------------
# Option to specify monitoring
# ---------------------------------------------------------------

set(DOCSTR "Build with simulation monitoring capabilities enabled")
sundials_option(SUNDIALS_BUILD_WITH_MONITORING BOOL ${DOCSTR} OFF)

# ---------------------------------------------------------------
# Enable Fortran interface?
# ---------------------------------------------------------------

# Fortran interface is disabled by default
set(DOCSTR "Enable Fortran 77 interfaces")
option(F77_INTERFACE_ENABLE "${DOCSTR}" OFF)

# Check that at least one solver with a Fortran 77 interface is built
if(NOT BUILD_ARKODE AND NOT BUILD_CVODE AND NOT BUILD_IDA AND NOT BUILD_KINSOL)
  if(F77_INTERFACE_ENABLE)
    print_warning("Enabled packages do not support Fortran 77 interface" "Disabling F77 interface")
    force_variable(F77_INTERFACE_ENABLE BOOL "${DOCSTR}" OFF)
  endif()
  hide_variable(F77_INTERFACE_ENABLE)
endif()

# Fortran 2003 interface is disabled by default
set(DOCSTR "Enable Fortran 2003 interfaces")
option(F2003_INTERFACE_ENABLE "${DOCSTR}" OFF)

if(F2003_INTERFACE_ENABLE)
  # F2003 interface only supports double precision
  if(NOT (SUNDIALS_PRECISION MATCHES "DOUBLE"))
    print_warning("F2003 interface is not compatible with ${SUNDIALS_PRECISION} precision"
                  "Disabling F2003 interface")
    force_variable(F2003_INTERFACE_ENABLE BOOL "${DOCSTR}" OFF)
  endif()

  # F2003 interface only supports 64-bit indices
  if(NOT (SUNDIALS_INDEX_SIZE MATCHES "64"))
    print_warning("F2003 interface is not compatible with ${SUNDIALS_INDEX_SIZE}-bit indicies"
                  "Disabling F2003 interface")
    force_variable(F2003_INTERFACE_ENABLE BOOL "${DOCSTR}" OFF)
  endif()

  # Put all F2003 modules into one build directory
  set(CMAKE_Fortran_MODULE_DIRECTORY "${CMAKE_BINARY_DIR}/fortran")

  # Allow a user to set where the Fortran modules will be installed
  set(DOCSTR "Directory where Fortran module files are installed")
  show_variable(Fortran_INSTALL_MODDIR STRING "${DOCSTR}" "fortran")
endif()

# ---------------------------------------------------------------
# Options to build static and/or shared libraries
# ---------------------------------------------------------------

option(BUILD_STATIC_LIBS "Build static libraries" ON)
option(BUILD_SHARED_LIBS "Build shared libraries" ON)

# Prepare substitution variable SUNDIALS_EXPORT for sundials_config.h
# When building shared SUNDIALS libraries under Windows, use
#      #define SUNDIALS_EXPORT __declspec(dllexport)
# When linking to shared SUNDIALS libraries under Windows, use
#      #define SUNDIALS_EXPORT __declspec(dllimport)
# In all other cases (other platforms or static libraries
# under Windows), the SUNDIALS_EXPORT macro is empty

if(BUILD_SHARED_LIBS AND WIN32)
  set(SUNDIALS_EXPORT
    "#ifdef BUILD_SUNDIALS_LIBRARY
#define SUNDIALS_EXPORT __declspec(dllexport)
#else
#define SUNDIALS_EXPORT __declspec(dllimport)
#endif")
else(BUILD_SHARED_LIBS AND WIN32)
  set(SUNDIALS_EXPORT "#define SUNDIALS_EXPORT")
endif(BUILD_SHARED_LIBS AND WIN32)

# Make sure we build at least one type of libraries
if(NOT BUILD_STATIC_LIBS AND NOT BUILD_SHARED_LIBS)
  print_warning("Both static and shared library generation were disabled"
                "Building static libraries was re-enabled")
  force_variable(BUILD_STATIC_LIBS BOOL "Build static libraries" ON)
endif(NOT BUILD_STATIC_LIBS AND NOT BUILD_SHARED_LIBS)

# ---------------------------------------------------------------
# Option to use the generic math libraries (UNIX only)
# ---------------------------------------------------------------

if(UNIX)
  option(USE_GENERIC_MATH "Use generic (std-c) math libraries" ON)
  # executables will be linked against -lm
  set(EXTRA_LINK_LIBS -lm)
  if(USE_GENERIC_MATH)
    # prepare substitution variable for sundials_config.h
    set(SUNDIALS_USE_GENERIC_MATH TRUE)
  endif(USE_GENERIC_MATH)
endif(UNIX)

# ---------------------------------------------------------------
# Check for POSIX timers
# ---------------------------------------------------------------
include(SundialsPOSIXTimers)
