=== debian/changelog ===
openmodelica (1.19.3-1) unstable; urgency=low

  * Automatic git build
 -- OpenModelica Build System <build@openmodelica.org>  Mon, 25 Jul 2022 13:52:57 -0000
